#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 LimeGreen
#property indicator_color2 OrangeRed
#property indicator_color3 DarkGray
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_level1 0

//
//
//
//
//

extern int    MaPeriod = 15;
extern int    MaMethod = MODE_SMA;
extern int    MaPrice  = PRICE_CLOSE;
extern double Smooth   = 3;

double value[];
double valueUp[];
double valueDn[];

//--------------------------------------------------------
//
//--------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,valueUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,valueDn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,value);
      IndicatorShortName("carbon ("+MaPeriod+")");
   return(0);
}
int deinit()
{
    return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   // DISTANCEHL15:=If(Mov(C,15,S)>H,-1*((Mov(C,15,S)-L)*100)/L,If(Mov(C,15,S)<L,((H-Mov(C,15,S))*100)/Mov(C,15,S),0));
   //
   //

   double alpha = 2.0/(Smooth+1.0);
   for(int i = limit; i >= 0; i--)
   {
      double ma = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i); if (ma==0) continue;
      valueUp[i] = 0;
      valueDn[i] = 0;
      value[i]   = 0;
         if (ma>High[i]) value[i]   = -100.0*(ma-Low[i])/Low[i];
         if (ma<Low[i] ) value[i]   =  100.0*(High[i]-ma)/ma;
         if (value[i]>0) { valueUp[i] = MathMax(valueUp[i+1]+alpha*(value[i]-valueUp[i+1]),0); value[i] = valueUp[i]; }
         if (value[i]<0) { valueDn[i] = MathMin(valueDn[i+1]+alpha*(value[i]-valueDn[i+1]),0); value[i] = valueDn[i]; }
   }
   return(0);
}